### The purpose of this file is to track the progress of implementing the bindings to the ImageMagick C API.

# [MagickWand Methods](https://imagemagick.org/script/magick-wand.php#:~:text=are%20found%20here%3A-,Magick%20Wand%20Methods,-Set%20or%20Get)
- [x] ClearMagickWand
- [x] CloneMagickWand
- [x] DestroyMagickWand
- [x] IsMagickWand
- [x] MagickClearException
- [x] MagickGetException
- [x] MagickGetExceptionType
- [x] MagickGetIteratorIndex
- [x] MagickQueryConfigureOption
- [x] MagickQueryConfigureOptions
- [x] MagickQueryFontMetrics
- [x] MagickQueryMultilineFontMetrics
- [x] MagickQueryFonts
- [x] MagickQueryFormats
- [x] MagickRelinquishMemory (private)
- [x] MagickResetIterator
- [x] MagickSetFirstIterator
- [x] MagickSetIteratorIndex
- [x] MagickSetLastIterator
- [x] MagickWandGenesis (private)
- [x] MagickWandTerminus (private)
- [x] NewMagickWand
- [ ] NewMagickWandFromImage
- [x] IsMagickWandInstantiated
# [Set or Get Magick Wand Properties](https://imagemagick.org/script/magick-wand.php#:~:text=Set%20or%20Get%20Magick%20Wand%20Properties)
- [x] MagickDeleteImageArtifact
- [x] MagickDeleteImageProperty
- [x] MagickDeleteOption
- [x] MagickGetAntialias
- [x] MagickGetBackgroundColor
- [x] MagickGetColorspace
- [x] MagickGetCompression
- [x] MagickGetCompressionQuality
- [x] MagickGetCopyright
- [x] MagickGetFilename
- [x] MagickGetFont
- [x] MagickGetFormat
- [x] MagickGetFilter
- [x] MagickGetGravity
- [x] MagickGetHomeURL
- [x] MagickGetImageArtifact
- [x] MagickGetImageArtifacts
- [x] MagickGetImageProfile
- [x] MagickGetImageProfiles
- [x] MagickGetImageProperty
- [x] MagickGetImageProperties
- [x] MagickGetInterlaceScheme
- [x] MagickGetInterpolateMethod
- [x] MagickGetOption
- [x] MagickGetOptions
- [x] MagickGetOrientation
- [x] MagickGetPackageName
- [x] MagickGetPage
- [x] MagickGetPointsize
- [x] MagickGetQuantumDepth
- [x] MagickGetQuantumRange
- [x] MagickGetReleaseDate
- [x] MagickGetResolution
- [x] MagickGetResource
- [x] MagickGetResourceLimit
- [x] MagickGetSamplingFactors
- [x] MagickGetSize
- [x] MagickGetSizeOffset
- [x] MagickGetType
- [x] MagickGetVersion
- [x] MagickProfileImage
- [x] MagickRemoveImageProfile
- [x] MagickSetAntialias
- [x] MagickSetBackgroundColor
- [x] MagickSetColorspace
- [x] MagickSetCompression
- [x] MagickSetCompressionQuality
- [x] MagickSetDepth
- [x] MagickSetExtract
- [x] MagickSetFilename
- [x] MagickSetFont
- [x] MagickSetFormat
- [x] MagickSetFilter
- [x] MagickSetGravity
- [x] MagickSetImageArtifact
- [x] MagickSetImageProfile
- [x] MagickSetImageProperty
- [x] MagickSetInterlaceScheme
- [x] MagickSetInterpolateMethod
- [x] MagickSetOption
- [x] MagickSetOrientation
- [x] MagickSetPage
- [x] MagickSetPassphrase
- [x] MagickSetPointsize
- [x] MagickSetProgressMonitor
- [x] MagickSetResourceLimit
- [x] MagickSetResolution
- [x] MagickSetSamplingFactors
- [x] MagickSetSeed
- [x] MagickSetSecurityPolicy
- [x] MagickSetSize
- [x] MagickSetSizeOffset
- [x] MagickSetType
# [Magick Wand Image Methods](https://imagemagick.org/script/magick-wand.php#:~:text=Magick%20Wand%20Image%20Methods)
- [ ] GetImageFromMagickWand
- [x] MagickAdaptiveBlurImage
- [x] MagickAdaptiveResizeImage
- [x] MagickAdaptiveSharpenImage
- [x] MagickAdaptiveThresholdImage
- [x] MagickAddImage
- [x] MagickAddNoiseImage
- [x] MagickAffineTransformImage
- [x] MagickAnnotateImage
- [ ] MagickAnimateImages
- [x] MagickAppendImages
- [x] MagickAutoGammaImage
- [x] MagickAutoLevelImage
- [x] MagickAutoOrientImage
- [x] MagickAutoThresholdImage
- [x] MagickBilateralBlurImage
- [x] MagickBlackThresholdImage
- [x] MagickBlueShiftImage
- [x] MagickBlurImage
- [x] MagickBorderImage
- [x] MagickBrightnessContrastImage
- [x] MagickCannyEdgeImage
- [x] MagickChannelFxImage
- [x] MagickCharcoalImage
- [x] MagickChopImage
- [x] MagickCLAHEImage
- [x] MagickClampImage
- [x] MagickClipImage
- [x] MagickClipImagePath
- [x] MagickClutImage
- [x] MagickCoalesceImages
- [x] MagickColorDecisionListImage
- [x] MagickColorizeImage
- [x] MagickColorMatrixImage
- [x] MagickColorThresholdImage
- [x] MagickCombineImages
- [x] MagickCommentImage
- [x] MagickCompareImagesLayers
- [x] MagickCompareImages
- [x] MagickComplexImages
- [x] MagickCompositeImage
- [x] MagickCompositeImageGravity
- [x] MagickCompositeLayers
- [ ] MagickConnectedComponentsImage
- [x] MagickContrastImage
- [x] MagickContrastStretchImage
- [x] MagickConvolveImage
- [x] MagickCropImage
- [x] MagickCycleColormapImage
- [x] MagickConstituteImage
- [x] MagickDecipherImage
- [x] MagickDeconstructImages
- [x] MagickDeskewImage
- [x] MagickDespeckleImage
- [ ] MagickDestroyImage
- [ ] MagickDisplayImage
- [ ] MagickDisplayImages
- [x] MagickDistortImage
- [x] MagickDrawImage
- [x] MagickEdgeImage
- [x] MagickEmbossImage
- [x] MagickEncipherImage
- [x] MagickEnhanceImage
- [x] MagickEqualizeImage
- [x] MagickEvaluateImage
- [ ] MagickEvaluateImages
- [x] MagickExportImagePixels
- [x] MagickExtentImage
- [x] MagickFlipImage
- [x] MagickFloodfillPaintImage
- [x] MagickFlopImage
- [ ] MagickForwardFourierTransformImage
- [x] MagickFrameImage
- [x] MagickFunctionImage
- [x] MagickFxImage
- [x] MagickGammaImage
- [x] MagickGaussianBlurImage
- [x] MagickGetImage
- [x] MagickGetImageAlphaChannel
- [x] MagickGetImageMask
- [x] MagickGetImageBackgroundColor
- [x] MagickGetImageBlob



